% *******************************************************
%	The IHRS project - The EP1 example process
%	Display a numerical result with the variable name.
% *******************************************************
%	31.01.2000 - last : 16.02.00 - OW|BR
%	DispNum.m
%	function DispNum ( paramnum, paramstr[, unitstr[, otherstr]] )
%		paramnum : array(1:9) of numerical parameters
%		paramstr : string containing name  of the numerical parameter
%		unitstr  : string containing units of the numerical parameter
%		otherstr : other string describing
% *******************************************************
% old version : function DispNum ( paramnum, paramstr, unitstr );

function DispNum ( varargin );

[reg, prop]=parseparams(varargin);
nargs=length(reg);
error(nargchk(1,9,nargs));		% should be as many as possible on a line
n_string_arg = length(prop);		% at least 1, the string, plus some parameters

if     n_string_arg < 1
	disp ( ' DispNum ( paramnum(1..9), paramstr[, unitstr[, otherstr]] ) is the correct syntax !' );
	error('Too few arguments.');
elseif n_string_arg == 1
	tempstr1 = [ ' Value of ', prop{1}, ' = ' ];
	tempstr = [ tempstr1, num2str( deal (reg {1}) ) ];
elseif n_string_arg == 2
	tempstr1 = [ ' Value of ', prop{1}, ' = ' ];
	tempstr2 = [ '  ', prop{2}, '  ! ' ];
	tempstr = [ tempstr1, num2str( deal (reg {1}) ), tempstr2 ];
elseif n_string_arg == 3
	tempstr1 = [ ' Value of ', prop{1}, ' = ' ];
	tempstr2 = [ '  ', prop{2} ];
	tempstr3 = [ '  ', prop{3}, '  ! ' ];
	tempstr = [ tempstr1, num2str( deal (reg {1}) ), tempstr2, tempstr3 ];
else
	disp ( ' DispNum ( paramnum(1..9), paramstr[, unitstr[, otherstr]] ) is the correct syntax !' );
	error('Too many arguments.');
end

disp ( tempstr );

% disp ( ' End of Program --- DispNum !' );
% *******************************************************