% *******************************************************
%	IHRS design and optimization using Genetic Algorithms 
%	Calculation of optimization-independent intermediate
%	terms of equations used in the most internal loop, i.e.
%	the one which are performed the largest numbre of times
%	Current implementation postulates O=1, M=1, N=1
% *******************************************************
%	14.02.2000 - last : xx.02.00 by PK
%	IndependentTerms.m
% *******************************************************

if helppri==1, help IndependentTerms; end
pausetext = 'Press any key ...';

%	Intermediate terms needed in the area calculation
%	Simplifying assumptions: O=1, M=1, N=1

O=1;
M=1;
N=1;

A_CP_h_po = zeros(P,O);
A_CP_h_pm = zeros(P,M);
A_CP_h_pn = zeros(P,N);
%A_dt_h_om = zeros(O,M);
%A_dt_h_on = zeros(O,N);

for p = 1:P
   for o = 1:O
      A_CP_h_po(p,o) = abs(Stream(p).CP) * ((1 / Stream(p).h) + (1 / StorageFluid(o).h_SF));
      if interpri > 0
         Dispnum (A_CP_h_po(p,o), 'A_CP_h_po(p,o)');
      end
   end
   for m = 1:M
      A_CP_h_pm(p,m) = Stream(p).CP * ((1 / Stream(p).h) + (1 / HotUtility(m).h));
      if interpri > 0
         Dispnum (A_CP_h_pm(p,m), 'A_CP_h_pm(p,m)');
      end
   end
	for n = 1:N
      A_CP_h_pn(p,n) = Stream(p).CP * ((1 / Stream(p).h) + (1 / ColdUtility(n).h));
      if interpri > 0
         Dispnum (A_CP_h_pn(p,n), 'A_CP_h_pn(p,n)');
      end
   end
end
%for o = 1:O
%   for m = 1:M
%      A_dt_h_om(o,m) = (1 /Dt_batch) * ((1 / StorageFluid(o).h_SF) + (1 / HotUtility(m).h));
%      if interpri > 0
%         Dispnum (A_dt_h_om(o,m), 'A_dt_h_om(o,m)');
%      end
%   end
%	for n = 1:N
%      A_dt_h_on(o,n) = (1 /Dt_batch) * ((1 / StorageFluid(o).h_SF) + (1 / ColdUtility(n).h));
%      if interpri > 0
%         Dispnum (A_dt_h_on(o,n), 'A_dt_h_on(o,n)');
%      end
%   end
%end

%	intermediate terms for mass balance calculation

MBB_k_fact = zeros(P,O);		%	for initial mass imbalance calculation (after one batch cycle)
MBB_kl_act = zeros(P,O,L);		%	for slice-wise mass inventory calculation

for p = 1:P
   for o = 1:O
      MBB_k_fact(p,o) = 3600 * Stream(p).CP_Dt / StorageFluid(o).cp_SF;
      if interpri > 0
         Dispnum (MBB_k_fact(p,o), 'MBB_k_fact(p,o)');
      end
      for l = 1:L
         MBB_kl_act(p,o,l) = 3600 * Dtl(l) * activity(l,p) * Stream(p).CP / StorageFluid(o).cp_SF;
         if interpri > 0
            Dispnum (MBB_kl_act(p,o,l), 'MBB_kl_act(p,o,l)');
         end
      end
   end
end

Array_TBCs_mean = zeros(1,G_SX+1);
Array_TBCs_min = zeros(1,G_SX+1);
%Array_Individuals_HR = zeros((G_SX+1)*I_SX);	%would be for storing all generated individual (not possible for large number of G_SX * I_SX !!!!
%Array_Individuals_TBCs = zeros((G_SX+1)*I_SX);

if interpri > 0
	disp(' ');
	disp ( ' End of Program --- IndependentTerms !' );
end
% ***************************************************