%********************************************
%	Function Ave : objective function
%	for EP1 project at LENI
%********************************************
%	01.03.00 - BR
%	22.03.00 - 30.03.00
%********************************************
function [yret1] = Ave (TBCs_mean, TBCs_min, HR_of_TBCs_min, Last_but_not_least)
%********************************************
global	HR_mode
global	Search_mode
global	G_SX
global	n_gen
global	Threshold_n_gen
global	NGENplot
global	delta_HR
global	TBCs_vs_HR
global 	N_HR
global	TBCs_max_approx
global	HR_ul
%********************************************
%	TBCs_mean			the current mean objective function value TBCs for display purpose
%	TBCs_min			the min  objective function value TBCs
%	HC_of_TBCs_min		the HR value for the min objective function value TBCs
%	Last_but_not_least	Flag = 0 except when done (to plot the best (min) TBCs, with its associated HR)
%	n_gen				the current equivalent number of generations
%	NGENplot		number of generations before refreshing plot

yret1 = 0;


if n_gen >= 0
	NoGEN = n_gen;
else
	NoGEN = 0;
end

if HR_mode == 1
   %	disp ( ' ' );
	%disp ( ' In RAve.m **' );
	dispnum ( NoGEN, 'NoGEN' );
	dispnum ( -TBCs_mean, '-OF_mean' );
	dispnum ( -TBCs_min, '-OF_min' );
	dispnum ( HR_of_TBCs_min, 'Side_Val_of_-OF_min' );
	%dispnum ( Last_but_not_least, 'Last_but_not_least' );

	subplot(3,1,3); hold on; plot( NoGEN, -TBCs_mean, 'k+', NoGEN, -TBCs_min, 'b.');
	if Last_but_not_least ~= 0,	plot( NoGEN, -TBCs_min, 'r*' ); end;	%	is it actually needed, since done in ROF ?

	yret1 = 989;

	%	dispnum(NoGEN   ,'1 NoGEN   ');
	%	dispnum(NGENplot,'1 NGENplot');
	if (floor(NoGEN/NGENplot)*NGENplot == NoGEN) | (Last_but_not_least ~= 0)
	%	dispnum(NoGEN   ,'2 NoGEN   ');
	%	dispnum(NGENplot,'2 NGENplot');
		subplot(3,1,1); hold off;
		plot(delta_HR / 2, TBCs_vs_HR(1,1), 'b.');	%	????
   	hold on; axis([0 HR_ul 0 2.0*TBCs_max_approx]); grid on; xlabel('Heat Recovery [kWh/batch]'); ylabel('TBCs [CHF/batch]');
   	for n_hr = 1:N_HR
    		plot((n_hr-1)*delta_HR, TBCs_vs_HR(1,n_hr), 'b.');	%	n_hr-1 since for HR=0, the index of the TBCS_vs_HR array should be one (index=0 are not allowed !) (refer to pre-allocation in VarInit)
   	end
   	if Last_but_not_least ~= 0
      	plot(-TBCs_min, HR_of_TBCs_min, 'r*');
   	end
		drawnow;	%	drawnow refreshes the plot (between two drawnow commands, points top plot are stored but wait a drawnow to be displayed)
	end	%	Draw not too often. Might be every gth generations (test No_GEN) !

else	%	minimization of TBCs, i.e. OF = TBCs
   if (Search_mode ~= 1) & (n_gen < Threshold_n_gen)
     	subplot(3,1,3); hold on; axis([0 G_SX 0 20*TBCs_max_approx]); grid on; xlabel('Generation [-]'); ylabel('Modif_Obj_Func [CHF/batch]'); hold off;
   else	%	i.e. Search_mode =1 or n_gen > Threshold_n_gen
      subplot(3,1,3); hold on; axis([0 G_SX 0 2*TBCs_max_approx]); grid on; xlabel('Generation [-]'); ylabel('TBCs [CHF/batch]'); hold off;      
   end
	%	disp ( ' ' );
	%disp ( ' In RAve.m **' );
	dispnum ( NoGEN, 'NoGEN' );
	dispnum ( TBCs_mean, 'OF_mean' );
	dispnum ( TBCs_min, 'OF_min' );
	dispnum ( HR_of_TBCs_min, 'Side_Val_of_OF_min' );
	%dispnum ( Last_but_not_least, 'Last_but_not_least' );

	subplot(3,1,3); hold on; plot( NoGEN, TBCs_mean, 'k+', NoGEN, TBCs_min, 'b.');
	if Last_but_not_least ~= 0,	plot( NoGEN, TBCs_min, 'r*' ); end;

	yret1 = 989;

	%	dispnum(NoGEN   ,'1 NoGEN   ');
	%	dispnum(NGENplot,'1 NGENplot');
	if (floor(NoGEN/NGENplot)*NGENplot == NoGEN) | (Last_but_not_least ~= 0)
	%	dispnum(NoGEN   ,'2 NoGEN   ');
	%	dispnum(NGENplot,'2 NGENplot');
		subplot(3,1,1); hold off;
		plot(delta_HR / 2, TBCs_vs_HR(1,1), 'b.');
 	   hold on; axis([0 HR_ul 0 2.0*TBCs_max_approx]); grid on; xlabel('Heat Recovery [kWh/batch]'); ylabel('TBCs [CHF/batch]');
 	   for n_hr = 1:N_HR
    		plot((n_hr-0.5)*delta_HR, TBCs_vs_HR(1,n_hr), 'b.');
   	end
   	if Last_but_not_least ~= 0
      	plot(HR_of_TBCs_min, TBCs_min, 'r*');
   	end
		drawnow;	%	drawnow refreshes the plot (between two drawnow commands, points top plot are stored but wait a drawnow to be displayed)
	end	%	Draw not too often. Might be every gth generations (test No_GEN) !
end	%	if HR_mode == 1
%disp (' End of RAve ! ');

%********************************************
%	end function Ave
%********************************************
