/* ----------------------------------------------------------------------------
  MLEvalData.cpp implementation of MLEvalData class

  BR K316 - K429
  AM K327 - K328

	see MLEvalData.h for more explanations
---------------------------------------------------------------------------- */
#ifndef _ml_eval_c_
#define _ml_eval_c_
#include "MLEvalData.h"
#include <vector>	// For the temperatures vector

int MLEvalData::NbEval = 0;

	/************************************************
	/* Constructor */
MLEvalData::MLEvalData () 
{
	NbEval = m_NbEval(+1); /* increment the number of clones; cf private part */
}
	/************************************************
	/* Constructor from another MLEValdata */
MLEvalData::MLEvalData (const MLEvalData& aData) 
{
	NbEval = m_NbEval(+1); /* increment the number of clones; cf private part */

	copy(aData);
}
	/*************************************************/
	/* Desructor			*/
MLEvalData::~MLEvalData() 
{
	NbEval = m_NbEval(-1);   /* decrement nr. of clones */
}
	/*************************************************/
	/* Create un new instance of MLEvalData */
GAEvalData *MLEvalData::clone()	const
{
	return new MLEvalData (*this);
}
	/*************************************************/
	/* Copy */
void
MLEvalData::copy(const GAEvalData& aData)
{
	MLEvalData &bData = (MLEvalData &) aData;  // should use dynamic cast 
	// MLEvalData &bData=dynamic_cast<MLEvalData &>(aData);
	_TempVec = bData._TempVec;
}
  /************************************************
  /*        Now create genome functions           *
  /************************************************
  /* here get the whole array */
double*
MLEvalData::GetGenome()
{
	return(_TempVec.begin());
}  
  /************************************************
  /* here write the array in objet */
void
MLEvalData::SetGenome( const int DoubleArraySize, double* DoubleArray )
{
//	printf("resize Array size %i\n",DoubleArraySize);
	_TempVec.resize(DoubleArraySize);
//	printf("assign Array size %i\n",DoubleArraySize);
	_TempVec.assign(DoubleArray,DoubleArray+DoubleArraySize);
}
  /************************************************
  /* here get the value at index */
double
MLEvalData::GetGenomeValue( int index )
{
	if(index>=_TempVec.size() || index<0)
		return 0;
	else
		return(_TempVec[index]);
}  
  /************************************************
  /* here if write after the array length, the array size is increased */
void
MLEvalData::SetGenomeValue( int index, double value )
{
	if(index<0) 
		{
		throw 1;
		}
	if(index>=_TempVec.size()) 
		{
		// resize with 0's 
		_TempVec.resize(index+1,0.0);
		}
	_TempVec[index]=value;
}  



  /************************************************
  /* Nbr of clone of MLEvalData in the programme */
int
MLEvalData::GetNbClone()
{
return m_NbEval(0);
}
  /************************************************
  /* number of objets MLEvalData existing in programme */
int
MLEvalData::m_NbEval(int incr)		//	incr = int [-1,+1]
{
	if (incr >= -1 && incr <= 1)
		return (NbEval + incr);
	else
	{
		printf ( " ERROR : incr out of bound in m_NbEval " );
		return -9999;
	}
}
#endif
